program Velmodel2
  
  use sep
  implicit none
  
  integer              :: n1,n2,n3
  real                 :: d1,d2,d3
  real                 :: o1,o2,o3
  
  real                 :: v,dev,r
  
  real,allocatable     :: model(:,:,:)
  
  integer              :: ii,jj,kk
  integer              :: c1,c2
  real                 :: n
  
  ! Header I/O
  call sep_init()
  
  call from_param("n1",n1,500)
  call from_param("n2",n2,500)
  call from_param("n3",n3,  1)
  
  call from_param("d1",d1,1.)
  call from_param("d2",d2,1.)
  call from_param("d3",d3,1.)
  
  call from_param("o1",o1,0.)
  call from_param("o2",o2,0.)
  call from_param("o3",o3,0.)
  
  call to_history("n1",n1)
  call to_history("n2",n2)
  call to_history("n3",n3)
  
  call to_history("d1",d1)
  call to_history("d2",d2)
  call to_history("d3",d3)
  
  call to_history("o1",o1)
  call to_history("o2",o2)
  call to_history("o3",o3)
  
  call from_param("v",v,1500.)
  call from_param("n",n,n1/4.)
  call from_param("dev",dev,1.1)
  call from_param('c1',c1,n1/2)
  call from_param('c2',c2,n2/2)
  
  call sep_close
  
  ! Allocate some memory
  allocate(model(n1,n2,n3)); model=0.
  
  ! Insert constant velocity
  model=v

  ! 10% velocity anomaly
  write(0,*)  nint(1./2.*n1-n),nint(1./2.*n1+n),nint(1./2.*n2-n),nint(1./2.*n2+n)
  do ii=1,n1
  do jj=1,n2
    r = sqrt((ii*d1-c1*d1)**2.+(c2*d2-jj*d2)**2.)
    model(ii,jj,:) = model(ii,jj,:)*(1+(dev-1)*exp(-(r)**2./(2.*n**2.)))
  end do
  end do
  
  ! Write model to file
  call srite("out",model,4*n1*n2*n3)
  
  ! Deallocate
  deallocate(model)
  call exit(0);
  
end program
